%token <int> INT
%token TIMES PLUS MINUS LPARA RPARA EOL
%start <Syntax.t> s
%left PLUS MINUS
%right TIMES
%{ open Syntax %}
%%

s: e1=e EOL           {e1}
e:  e1=e TIMES e2=e   {App(e1,Mult,e2)}
  | e1=e PLUS e2=e    {App(e1,Plus,e2)}
  | e1=e MINUS e2=e   {App(e1,Minus,e2)}
  | MINUS e1=e        {App(Const 0,Minus,e1)}
  | LPARA e1=e RPARA  {e1}
  | i1=INT            {Const(i1)}
