
module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | THEN
    | IF
    | ID
    | EOL
    | ELSE
  
end

include MenhirBasics

type ('s, 'r) _menhir_state = 
  | MenhirState00 : ('s, _menhir_box_s) _menhir_state
    (** State 00.
        Stack shape : .
        Start symbol: s. *)

  | MenhirState01 : (('s, _menhir_box_s) _menhir_cell1_IF, _menhir_box_s) _menhir_state
    (** State 01.
        Stack shape : IF.
        Start symbol: s. *)

  | MenhirState04 : ((('s, _menhir_box_s) _menhir_cell1_IF, _menhir_box_s) _menhir_cell1_expr, _menhir_box_s) _menhir_state
    (** State 04.
        Stack shape : IF expr.
        Start symbol: s. *)

  | MenhirState06 : (((('s, _menhir_box_s) _menhir_cell1_IF, _menhir_box_s) _menhir_cell1_expr, _menhir_box_s) _menhir_cell1_expr, _menhir_box_s) _menhir_state
    (** State 06.
        Stack shape : IF expr expr.
        Start symbol: s. *)


and ('s, 'r) _menhir_cell1_expr = 
  | MenhirCell1_expr of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state

and _menhir_box_s = 
  | MenhirBox_s of (unit) [@@unboxed]

let _menhir_action_1 =
  fun () ->
    (
# 6 "parser.mly"
                                     (())
# 58 "parser.ml"
     : (unit))

let _menhir_action_2 =
  fun () ->
    (
# 7 "parser.mly"
                                     (())
# 66 "parser.ml"
     : (unit))

let _menhir_action_3 =
  fun () ->
    (
# 8 "parser.mly"
                                     (())
# 74 "parser.ml"
     : (unit))

let _menhir_action_4 =
  fun () ->
    (
# 5 "parser.mly"
                                     (())
# 82 "parser.ml"
     : (unit))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ELSE ->
        "ELSE"
    | EOL ->
        "EOL"
    | ID ->
        "ID"
    | IF ->
        "IF"
    | THEN ->
        "THEN"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37-39"]
  
  let rec _menhir_run_09 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_s =
    fun _menhir_stack _tok ->
      match (_tok : MenhirBasics.token) with
      | EOL ->
          let _v = _menhir_action_4 () in
          MenhirBox_s _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_01 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_s) _menhir_state -> _menhir_box_s =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | IF ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState01
      | ID ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_1 () in
          _menhir_run_03 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState01 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_03 : type  ttv_stack. ((ttv_stack, _menhir_box_s) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_s) _menhir_state -> _ -> _menhir_box_s =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | THEN ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | IF ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState04
          | ID ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _v = _menhir_action_1 () in
              _menhir_run_05 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState04 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_05 : type  ttv_stack. (((ttv_stack, _menhir_box_s) _menhir_cell1_IF, _menhir_box_s) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_s) _menhir_state -> _ -> _menhir_box_s =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ELSE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | IF ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState06
          | ID ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _ = _menhir_action_1 () in
              _menhir_run_07 _menhir_stack _menhir_lexbuf _menhir_lexer _tok
          | _ ->
              _eRR ())
      | EOL | THEN ->
          let MenhirCell1_expr (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _v = _menhir_action_2 () in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_07 : type  ttv_stack. (((ttv_stack, _menhir_box_s) _menhir_cell1_IF, _menhir_box_s) _menhir_cell1_expr, _menhir_box_s) _menhir_cell1_expr -> _ -> _ -> _ -> _menhir_box_s =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _tok ->
      let MenhirCell1_expr (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
      let _v = _menhir_action_3 () in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_expr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_s) _menhir_state -> _ -> _menhir_box_s =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState00 ->
          _menhir_run_09 _menhir_stack _tok
      | MenhirState06 ->
          _menhir_run_07 _menhir_stack _menhir_lexbuf _menhir_lexer _tok
      | MenhirState04 ->
          _menhir_run_05 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState01 ->
          _menhir_run_03 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let rec _menhir_run_00 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_s =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | IF ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState00
      | ID ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _ = _menhir_action_1 () in
          _menhir_run_09 _menhir_stack _tok
      | _ ->
          _eRR ()
  
end

let s =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_s v = _menhir_run_00 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
