%token <int> INT
%token TIMES PLUS LPARA RPARA EOL
%start <Syntax.t> s
%{ open Syntax %}
%%

/* ATTENTION SHIFT-REDUCE CONFLICTS */

s: e1=e EOL          {e1}
e:
  | e1=e TIMES e2=e   {App(e1,Mult,e2)}
  | e1=e PLUS e2=e    {App(e1,Plus,e2)}
  | LPARA e1=e RPARA  {e1}
  | i1=INT            {Const(i1)}
