%token <int> INT
%token DOLLAR SHARP AMP AT EOL PARG PARD
%start <Syntax.t> s
%right AT
%left DOLLAR SHARP
%nonassoc AMP
%{ open Syntax %}
%%
s: e1=e EOL          {e1}
e:  e1=e AT e2=e     {App(e1,At,e2)}
  | e1=e DOLLAR e2=e {App(e1,Dollar,e2)} 
  | e1=e SHARP e2=e  {App(e1,Sharp,e2)} 
  | e1=e AMP e2=e    {App(e1,Amp,e2)}
  | PARG e1=e PARD   {e1}
  | i1=INT           {Const(i1)}
